#!/usr/bin/python
# -*- coding: utf-8 -*-
import xbmcaddon
import xbmcplugin
import xbmcgui
import sys
import urllib, urllib2
import re

pluginhandle = int(sys.argv[1])

def index():
        xbmcplugin.addSortMethod(pluginhandle, xbmcplugin.SORT_METHOD_DATE)
        xbmcplugin.addSortMethod(pluginhandle, xbmcplugin.SORT_METHOD_LABEL)
        content = getUrl("http://gdata.youtube.com/feeds/api/videos?author=stoersendertv&max_results=1000&orderby=published")
        spl=content.split('<entry>')
        for i in range(1,len(spl),1):
          entry=spl[i]
          match=re.compile('<id>http://gdata.youtube.com/feeds/api/videos/(.+?)</id>', re.DOTALL).findall(entry)
          id=match[0]
          match=re.compile("<title type='text'>(.+?)</title>", re.DOTALL).findall(entry)
          title=match[0]
          match=re.compile("<content type='text'>(.+?)</content>", re.DOTALL).findall(entry)
          desc=match[0]
          match=re.compile("<published>(.+?)T", re.DOTALL).findall(entry)
          splDate=match[0].split("-")
          date=splDate[2]+"."+splDate[1]+"."+splDate[0]
          thumb="http://img.youtube.com/vi/"+id+"/0.jpg"
          addLink(title,id,'playVideo',thumb,desc,date)
        xbmcplugin.endOfDirectory(pluginhandle)

def playVideo(youtubeID):
        fullData = "plugin://plugin.video.youtube/?path=/root/video&action=play_video&videoid=" + youtubeID
        listitem = xbmcgui.ListItem(path=fullData)
        return xbmcplugin.setResolvedUrl(pluginhandle, True, listitem)

def getUrl(url):
        req = urllib2.Request(url)
        req.add_header('User-Agent', 'Mozilla/5.0 (Windows NT 6.1; rv:11.0) Gecko/20100101 Firefox/13.0')
        response = urllib2.urlopen(req)
        link=response.read()
        response.close()
        return link

def addLink(name,url,mode,iconimage,desc,date):
        u=sys.argv[0]+"?url="+urllib.quote_plus(url)+"&mode="+str(mode)
        ok=True
        liz=xbmcgui.ListItem(name, iconImage="DefaultVideo.png", thumbnailImage=iconimage)
        liz.setInfo( type="Video", infoLabels={ "Title": name, "Plot": desc, "Date": date} )
        liz.setProperty('IsPlayable', 'true')
        ok=xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=u,listitem=liz)
        return ok

def parameters_string_to_dict(parameters):
    ''' Convert parameters encoded in a URL to a dict. '''
    paramDict = {}
    if parameters:
        paramPairs = parameters[1:].split("&")
        for paramsPair in paramPairs:
            paramSplits = paramsPair.split('=')
            if (len(paramSplits)) == 2:
                paramDict[paramSplits[0]] = paramSplits[1]
    return paramDict

params=parameters_string_to_dict(sys.argv[2])
mode=params.get('mode')
url=params.get('url')
if type(url)==type(str()):
  url=urllib.unquote_plus(url)

if mode == 'playVideo':
    playVideo(url)
else:
    index()
